Imports ATSMS
Imports ATSMS.SMS

Public Class MainForm

    Private WithEvents oGsmModem As New GSMModem

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        CheckForIllegalCrossThreadCalls = False
    End Sub

    
    Private Sub btnPhone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click

        If cboComPort.Text = String.Empty Then
            MsgBox("COM Port must be selected", MsgBoxStyle.Information)
            Return
        End If

        oGsmModem.Port = cboComPort.Text

        If cboBaudRate.Text <> String.Empty Then
            oGsmModem.BaudRate = Convert.ToInt32(cboBaudRate.Text)
        End If

        If cboDataBit.Text <> String.Empty Then
            oGsmModem.DataBits = Convert.ToInt32(cboDataBit.Text)
        End If

        If cboStopBit.Text <> String.Empty Then
            Select Case cboStopBit.Text
                Case "1"
                    oGsmModem.StopBits = Common.EnumStopBits.One
                Case "1.5"
                    oGsmModem.StopBits = Common.EnumStopBits.OnePointFive
                Case "2"
                    oGsmModem.StopBits = Common.EnumStopBits.Two
            End Select
        End If

        If cboFlowControl.Text <> String.Empty Then
            Select Case cboFlowControl.Text
                Case "None"
                    oGsmModem.FlowControl = Common.EnumFlowControl.None
                Case "Hardware"
                    oGsmModem.FlowControl = Common.EnumFlowControl.RTS_CTS
                Case "Xon/Xoff"
                    oGsmModem.FlowControl = Common.EnumFlowControl.Xon_Xoff
            End Select
        End If

        Try
            oGsmModem.Connect()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
            Return
        End Try

        Try
            oGsmModem.NewMessageIndication = True
        Catch ex As Exception

        End Try

        btnSendvCard.Enabled = True
        btnSendvCalendar.Enabled = True
        btnSendWapPush.Enabled = True
        btnDisconnect.Enabled = True

        MsgBox("Connected to phone successfully !", MsgBoxStyle.Information)

    End Sub


    Private Sub btnDisconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDisconnect.Click
        Try
            oGsmModem.Disconnect()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical)
        End Try

        btnSendvCard.Enabled = False
        btnSendvCalendar.Enabled = False
        btnSendWapPush.Enabled = False
        btnDisconnect.Enabled = False
        btnConnect.Enabled = True

    End Sub


    Private Sub btnSendvCard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendvCard.Click
        If txtPhoneNumber.Text.Trim = String.Empty Then
            MsgBox("Phone number must not be empty", MsgBoxStyle.Critical)
            Return
        End If

        Dim v As New vCard
        v.LastName = "Magic Source"
        v.Emails = New vCard.vEmails()
        v.Emails.Add(New vCard.vEmail("magic_opensource@hotmail.com"))
        v.Telephones = New vCard.vTelephones
        v.Telephones.Add(New vCard.vTelephone("0192292309", vCard.vLocations.CELL, vCard.vPhoneTypes.VOICE, True))
        txtMsg.Text = v.ToString
        Try
            Dim msgId As String = oGsmModem.SendSMS(txtPhoneNumber.Text, v.ToString)
            MsgBox("vCard sent. Message id is " + msgId)
        Catch ex As Exception
            MsgBox(ex.Message & ". Make sure your SIM memory is not full.", MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub btnSendvCalendar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendvCalendar.Click
        If txtPhoneNumber.Text.Trim = String.Empty Then
            MsgBox("Phone number must not be empty", MsgBoxStyle.Critical)
            Return
        End If

        Dim v As New vCalendar
        Dim vE As New vCalendar.vEvent
        vE.DTStart = New Date
        vE.DTEnd = New Date
        vE.Organizer = "Test Org"
        vE.Summary = "Test Summary"
        v.Events.Add(vE)
        txtMsg.Text = v.ToString
        Try
            Dim msgId As String = oGsmModem.SendSMS(txtPhoneNumber.Text, v.ToString)
            MsgBox("vCalendar sent. Message id is " + msgId)
        Catch ex As Exception
            MsgBox(ex.Message & ". Make sure your SIM memory is not full.", MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub btnSendWapPush_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendWapPush.Click
        If txtPhoneNumber.Text.Trim = String.Empty Then
            MsgBox("Phone number must not be empty", MsgBoxStyle.Critical)
            Return
        End If
        Dim href As String = "http://atopensource.110mb.com"
        Dim text As String = "Share your mobile today"
        Dim body As String = New WapPushMessage(href, text).ToString
        oGsmModem.Encoding = ATSMS.Common.EnumEncoding.Hex_Message
        Try
            Dim msgId As String = oGsmModem.SendSMS(txtPhoneNumber.Text, body)
            MsgBox("Message sent. Message id is " + msgId)
        Catch ex As Exception
            MsgBox(ex.Message & ". Make sure your SIM memory is not full.", MsgBoxStyle.Critical)
        End Try
    End Sub
End Class
